<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Plugins Docs Source: twilio/twilio.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Plugins Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton.html">ableton/ableton</a></li><li><a href="module-control_control.html">control/control</a></li><li><a href="module-d-pro_d-pro.html">d-pro/d-pro</a></li><li><a href="module-data_data.html">data/data</a></li><li><a href="module-devices_device.html">devices/device</a></li><li><a href="module-devices_devices.html">devices/devices</a></li><li><a href="module-logic_logic.html">logic/logic</a></li><li><a href="module-messenger.html">messenger</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-sound_sound.html">sound/sound</a></li><li><a href="module-telegram_client.html">telegram/client</a></li><li><a href="module-telegram_telegram.html">telegram/telegram</a></li><li><a href="module-time_time.html">time/time</a></li><li><a href="module-tradfri_tradfri.html">tradfri/tradfri</a></li><li><a href="module-twilio_phone.html">twilio/phone</a></li><li><a href="module-twilio_twilio.html">twilio/twilio</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-ableton_ableton-Liveset.html">ableton/ableton~Liveset</a></li><li><a href="module-control_control-SessionControl.html">control/control~SessionControl</a></li><li><a href="module-d-pro_d-pro-Show.html">d-pro/d-pro~Show</a></li><li><a href="module-data_data-Data.html">data/data~Data</a></li><li><a href="module-data_data-CollectionAPI.html">data/data~CollectionAPI</a></li><li><a href="module-devices_device-Device.html">devices/device~Device</a></li><li><a href="module-devices_device-UDPdevice.html">devices/device~UDPdevice</a></li><li><a href="module-devices_device-OSCdevice.html">devices/device~OSCdevice</a></li><li><a href="module-devices_device-TCPdevice.html">devices/device~TCPdevice</a></li><li><a href="module-devices_device-Webdevice.html">devices/device~Webdevice</a></li><li><a href="module-devices_device-Serialdevice.html">devices/device~Serialdevice</a></li><li><a href="module-devices_device-Mididevice.html">devices/device~Mididevice</a></li><li><a href="module-logic_logic-Logic.html">logic/logic~Logic</a></li><li><a href="module-logic_logic-Condition.html">logic/logic~Condition</a></li><li><a href="module-logic_logic-Listener.html">logic/logic~Listener</a></li><li><a href="module-logic_logic-PEventListener.html">logic/logic~PEventListener</a></li><li><a href="module-messenger-Messenger.html">messenger~Messenger</a></li><li><a href="module-messenger-Conversation.html">messenger~Conversation</a></li><li><a href="module-messenger-Agent.html">messenger~Agent</a></li><li><a href="module-plugin-Plugin.html">plugin~Plugin</a></li><li><a href="module-plugin-Collection.html">plugin~Collection</a></li><li><a href="module-plugin-Item.html">plugin~Item</a></li><li><a href="module-telegram_client-Agent.html">telegram/client~Agent</a></li><li><a href="module-telegram_client-Client.html">telegram/client~Client</a></li><li><a href="module-telegram_client-Bot.html">telegram/client~Bot</a></li><li><a href="module-telegram_telegram-Telegram.html">telegram/telegram~Telegram</a></li><li><a href="module-telegram_telegram-Conversation.html">telegram/telegram~Conversation</a></li><li><a href="module-telegram_telegram-Dialogue.html">telegram/telegram~Dialogue</a></li><li><a href="module-telegram_telegram-DialogueCondition.html">telegram/telegram~DialogueCondition</a></li><li><a href="module-telegram_telegram-Chat.html">telegram/telegram~Chat</a></li><li><a href="module-telegram_telegram-Message.html">telegram/telegram~Message</a></li><li><a href="module-twilio_phone-Phone.html">twilio/phone~Phone</a></li><li><a href="module-twilio_twilio-Switchboard.html">twilio/twilio~Switchboard</a></li><li><a href="module-twilio_twilio-SmsIn.html">twilio/twilio~SmsIn</a></li><li><a href="module-twilio_twilio-Call.html">twilio/twilio~Call</a></li><li><a href="module-twilio_twilio-CallIn.html">twilio/twilio~CallIn</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: twilio/twilio.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* sets the routing for incomming calls and sms and routes outgoing sms and calls to phone interface
* takes a set of phone/twilio instances
*
* @requires twilio
* @requires json5
*
* @requires phone
* @requires plugin
* @requires logic
*
* @module twilio/twilio
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const JSON5 = require('json5')
const phone = require('./phone.js')
const plugin = require('../plugin.js')
const twilio = require('twilio')
const logic = require('../logic/logic.js')

var schema = require('./schema.json')

/**
*
*/
class Switchboard extends plugin.Plugin {
  constructor() {
    super(schema)
    
    /** level specific synonym for player that is different per session. */
    //this.roles = [{name:"playerA"}]
    
    /** target and agent if nothing was specified */
    this.defaults = {agent:"", target:"player"}
    
    /** list of twilio Studio flows that were found under given authentification */
    this.flows = {}
  }
  
  setup(config) {
    return new Promise((resolve, reject) => {
      this.update(config.settings)
      super.setup(config)
      .then(result => {
        this.phone.add = data => {
          data['url'] = this.url
          data['game_name'] = this.game.name
          data['files'] = this.files
          data['foreignContact'] = this.foreignContact.bind(this)
          this.phone.items[data.name] = new phone.Phone(data, this.app)
          this.schema.definitions.agent.enum.push(data.name)
          this.schemaUpdate(this.schema)
        }
        return this.phone.collectItems()
      })
      .then(result =>  {
        resolve(this.schema)
      })
      .catch(error => {
        log.error(this.name, error)
        reject(error)
      })
    })
  }
  
  /**
  * (re)establish twilio client with updated settings
  */
  update(settings) {
    this.settings = settings
    if(settings.hasOwnProperty('sid') &amp;&amp; settings.hasOwnProperty('token')) {
      try {
        this.client = new twilio(settings.sid, settings.token)
  			log.info(this.name, 'twilio client connected:')
  			log.info(this.name, settings)
  			// Store properties of all twilio studio flows created in twilio web interface
  			this.client.studio.flows.each(flow => this.flows[flow.sid] = flow)
      } catch(error) {
        log.error(this.name, "Failed connecting twilio client")
        log.error(this.name, error)
      }
		} else {
			log.error(this.name, "couldn't connect to twilio. Sid and or token missing.")
		}
  }
  
  /**
  * evaluate player and agent, then create conversation
  */
  cue(data, session) {
    return new Promise(function(resolve, reject) {
      for(let item in data) {
        this.evaluate(data[item], session)
        .then(function(result) {
          for(let player of result.player) {
            let props = {db:this.db, player:player, agent:result.agent, callback:session.callback, session:session._id, path:session.path, variables:session.variables, flows:this.flows, settings:this.settings}
            Object.assign(data[item], props)
            switch(item) {
              case "smsin":
                let smsin = new SmsIn(data[item])
                return resolve(smsin.cancel.bind(smsin))
              case "smsout":
                let conv = new Conversation(data[item])
                conv.send(data[item].text)
                .then(result => {
                  if(result &amp;&amp; data[item].hasOwnProperty("next")){
                    return resolve(data[item].next)
                  }
                  return resolve(undefined)
                })
                .catch(error => {
                  log.error(this.name, error)
                })
                break
              case "call":
                let callout = new Call(data[item])
                callout.init()
                .then(result => {
                  callout.outbound()
                  return resolve(callout.cancel.bind(callout))
                })
                .catch(error => {
                  log.error(this.name, error)
                  return reject(error)
                })
                break
              case "callin":
                let callin = new Call(data[item])
                callin.init()
                .then(result => {
                  callin.inbound()
                  return resolve(callin.cancel.bind(callin))
                })
                .catch(error => {
                  log.error(this.name, error)
                  return reject(error)
                })
                break
              case "flow":
                // let flow = new Flow(data[item])
                this.executeFlow(data[item], session.variables)
                return resolve(undefined)
            }
          }
        }.bind(this))
        .catch(function(error){
          log.error(this.name, "could not evaluate " + item)
          log.error(this.name, error)
          return resolve(undefined)
        }.bind(this))    
      }
    }.bind(this))
  }
  
  /**
	* is executed by phone if there is a sms or call contact by a number that has no routing registered
	* adds callee with number property to player collection if it does not exist
  */
  foreignContact(telnumber, default_level) {
    let level = ""
    if(default_level.hasOwnProperty("de")) {
      level = default_level["de"]
    } else {
      log.warn(this.name, "when opening default level, no level in 'de' language was found")
    }
    this.db.player.find({telnumber:telnumber})
    .then(res => {
      if(!res.length) {
        return this.db.player.insert({telnumber:telnumber})
      } else {
        if(res[0].hasOwnProperty("language")) {
          if(default_level.hasOwnProperty(res[0].language)) {
            level = default_level[res[0].language]
          }
        }
        return
      }
    })
    .then(res => {
      return this.game.createSession({level:level, "arguments":[{collection:"player", query:{telnumber:telnumber}}]})
    })
    .then(result => {
      log.info(this.name, "created default level " + level + " with player " + telnumber)
    })
    .catch(err => {
      log.error(this.name, err)
    })
  }
  
  /**
  * start a Studio Flow
  *
  * fetches a list of all flows for this account and triggers using the friendly name attribute.
  * allows forwarding json data to flow that can be accessed in the flow.
  *
  * @param {Object} properties - Properties used to identify the flow and what to forward
  * @param {Phone} properties.agent - Agent the flow is associated with (from number)
  * @param {Object} properties.player - Player the flow is associated with (to number)
  * @param {Object} [properties.parameters={}] - Data to forward to flow
  */
  executeFlow(properties, variables) {
    var flow_exists = false
    for(let flow in this.flows) {
      var params = []
      if(this.flows[flow].friendlyName == properties.execute) {
        flow_exists = true
        let param_promises = []
        if(properties.hasOwnProperty("parameter")) {
          for(let param in properties.parameter) {
            param_promises.push(variables.review(properties.parameter[param]))
            params.push(param)
          }
        }
        Promise.all(param_promises)
        .then(result => {
          let parameters = {session:properties.session.toString()}
          params.forEach((param, index) => {
            parameters[param] = result[index]
          })
          return this.client.studio.flows(this.flows[flow].sid).executions .create({parameters:parameters, to: properties.player.telnumber, from: properties.agent.settings.telnumber})
        })
        .then(execution => {
          log.debug(this.name, "Executed Studio Flow: " + execution.sid + " " + properties.execute)
          return
        })
        .catch(error => {
          log.error(this.name, error)
        })
      }
    }
    if(!flow_exists) {
      log.error(this.name, "Did not find Studio Flow " + properties.execute)
    }
  }

  /**
  * Get list of players based on role or query
  * If target is a valid role, make it a query that searches for player documents with this role
  *
  * 'from' and 'to' keys are treated as synonyms to 'target' key
  *
  * check if agent exists
  * 
  * @param {Object} properties - operation properties
  * @param {string} properties.agent - addresses phone device object 
  * @param {string} properties.target - either a rolename or a player DB query
  *
  * @returns {Promise} result - returns array of players and the agents phone object
  */
  evaluate(properties, session) {
    return new Promise(function(resolve, reject) {
      if(properties.hasOwnProperty('from')) {
        properties["target"] = properties.from
      }else if(properties.hasOwnProperty('to')) {
        properties["target"] = properties.to
      } else if(!properties.target) {
        properties["target"] = this.defaults.target
      }
      if(!properties.agent) {
        properties["agent"] = this.defaults.agent
      }
      
      if(!this.phone.items.hasOwnProperty(properties.agent)) {
        return reject(new Error('no such agent ' + properties.agent))
      }
      
      let agent = this.phone.items[properties.agent]
      
      let reference = session.variables.getReference(properties.target)
      if(!reference) {
        return reject(new Error('failed to resolve player'))
      }
      properties.target = reference.query
      
      if(!properties.target) {
        return reject(new Error('failed to resolve player'))
      }
      
      log.debug(this.name + " player query", properties.target)
      this.db.player.find(properties.target) 
      .then(function(player) {
        if(player.length) {
          for(let plyr of player) {
            if(!plyr.hasOwnProperty('telnumber')) {
              return reject(new Error('Found player but telnumber property is missing: ' + plyr.name))
            }
          }
          return resolve({player:player,agent:agent})
        } else {
          return reject(new Error('No player found by query: ' + JSON.stringify(properties.target)))
        }
      })
    }.bind(this))
  }
}

class Conversation {
  constructor(properties) {
    Object.assign(this, properties)
    this.name = this.session + " conversation"
  }
  
  /**
  * prevent any future events
  * removes registration for this contact from assigned phone instances
  */
  cancel() {
    log.info(this.name, "Conversation canceled")
  }
  
  /**
  * 
  * @param {string} text - message content
  *
  * @returns {Promise} true if sending was successfull. Else false
  */
  send(text) {
    return new Promise((resolve, reject) => {
      this.variables.review(text)
      .then(reviewed_text => {
        this.agent.sendSms(this.player.telnumber, reviewed_text, function(error, message) {
          if(error) {
            log.warn(this.name, "error when sending sms from " + this.agent.name + " to " + this.player.telnumber)
            log.warn(this.name, error)
            return resolve(false)
          } else {
            log.info(this.name, this.agent.name + ' sent: "' + message.body + '" to ' + message.to)
            return resolve(true)
          }
        }.bind(this))
      })
      .catch(error => {
        log.error(this.name, error)
      })
    })
  }
}

/**
* 
* sms in conversations are started from the beginning if there was a restart!
*/
class SmsIn extends Conversation {
  constructor(properties) {
    super(properties)
    this.name = this.session + " sms in"
    
    /** stacks all incoming messages during this conversation */
    this.incoming = []
    
    if(this.hasOwnProperty("timeout")) {
      log.debug(this.name, "next timeout in " + this.timeout.time[0])
      this.timer = setTimeout(this.time.bind(this), this.timeout.time[0]*1000)
    }
    
    this.agent.registerSmsIn(properties.player.telnumber, this.path, properties.priority, this.route.bind(this))
  }
  
  /**
  * check incoming messages on matches.
  *
  * if any, dispatch first next in list of match Promises 
  */
  route(telnumber, message) {
    return new Promise((resolve, reject) => {
      message = message.replace(/(\r\n|\n|\r|\\|\'|\")/gm," ") // replace line breaks, escape characters with single whitespace
      message = message.replace(/([ ]{2,})/gm," ")  // replace double or more whitespace characters with single whitespace
      message = message.trim() // remove leading and ending whitespaces
      log.info(this.name, 'incoming sms: "' + message + '" from ' + this.player.telnumber + " to " + this.agent.name)
      clearTimeout(this.timer)
      
      this.incoming.push(message)
      
      var sms_reaction
      
      let condition_promises = []
      if(this.hasOwnProperty("if")) {
        for(let if_condition of this["if"]) {
            if_condition["value"] = message
            let condition = new logic.Condition(if_condition, this.variables)
            condition_promises.push(this.match(condition, if_condition))
        }
      }
      Promise.all(condition_promises)
      .then(result => {
        for(let react of result) {
          if(react) {
            
            /*if(react.hasOwnProperty("next")) {
              this.callback(react.next)
            }*/
            sms_reaction = react
            sms_reaction["method"] = "if"
            //return resolve(react)
            return this.variables.store({match:react.match,text:message})
          }
        }
        
        if (this.hasOwnProperty("else")) {
          let else_react = this.reaction(this["else"])
          /*if(else_react.hasOwnProperty("next")) {
            this.callback(else_react.next)
          }*/
          sms_reaction = else_react
          sms_reaction["method"] = "else"
          //return resolve(else_react)
        } else {
          sms_reaction = {type:'ignore'}
          log.info(this.name, 'no match on message "' + message + '" from ' + telnumber + " and no else defined")
        }
        
        //return resolve({type:'ignore'})
        
        return this.variables.store({text:message})
      })
      .then(result => {
        if(sms_reaction.hasOwnProperty("text")) {
          return this.variables.review(sms_reaction.text)
        }
        return undefined
      })
      .then(result => {
        if(sms_reaction.hasOwnProperty("text")) {
          if(result) {
            sms_reaction.text = result
          }
          log.info(this.name, sms_reaction["method"] + " response to " + this.player.telnumber + ": " + sms_reaction.text)
        }
        
        if(sms_reaction.hasOwnProperty("next")) {
          this.callback(sms_reaction.next)
        }
        return resolve(sms_reaction)
      })
      .catch(error => {
        log.error(this.name, error)
      })
    })
  }
  
  /**
  * very similar to logic.Condition.match. Checks for responses before dispatching next 
  */
  match(condition_instance, properties) {
    return new Promise((resolve, reject) => {
      condition_instance.evaluate()
      .then(result => {
        if(result.value) {
          if(Array.isArray(result.condition)) {
            if(result.condition) {
              log.debug(this.name, "checking for '" + result.condition.join(',').substring(0, 30) + "'... in '" + result.value + "'")
            }
          } else if (typeof result.condition === "string") {
            log.debug(this.name, "checking for '" + result.condition.substring(0, 30) + "' in '" + result.value + "'")
          } else {
            log.debug(this.name, "checking for '" + result.condition + "' in '" + result.value + "'")
          }
          
          //log.debug(this.name, "checking for '" + result.condition + "' in '" + result.value + "'")
          return condition_instance.survey(result.value, result.condition)
        } else {
          return undefined
        }
      })
      .then(result => {
        if(result) {
          let react = this.reaction(properties)
          //if(react.hasOwnProperty("next")) {
          //  this.variables.store({match:result,text:properties.value})
          //}
          react["match"] = result
          return resolve(react)
        }
        return resolve(undefined)
      })
      .catch(error => {
        log.error(this.name, error)
      })
    })
  }
  
  /**
  * time Event dispatched after time elapsed
  */
  time() {
    let react = this.reaction(this.timeout)
    if(react.type == "respond") {
      this.send(react.text)
    }
    if(react.hasOwnProperty("next")) {
      this.callback(react.next)
    }
    if(this.timeout.hasOwnProperty("respond")) {
      if(this.timeout.count+1 &lt; this.timeout.respond.length) {
        let timespan = this.timeout.time[(this.timeout.count+1)%this.timeout.time.length]
        log.info(this.name, "Next Timeout in " + timespan)
        this.timer = setTimeout(this.time.bind(this), timespan*1000)
      }
    } else {
      log.warn(this.name, "can not install further timeouts. No responses defined.")
    }
    
  }
  
  /**
  * check for next and respond property.
  * dispatch next if there is no respond or if the last respond is called (count)
  * write message to local cue storage if it let to dispatching next cue
  *
  * returns either what sms text to send (as response), or to ignore
  *
  * @param {Object} react - contains information about if/how to react
  */
  reaction(react) {
    let return_value = {}
    if(react.hasOwnProperty("respond")) {
      if(!react.hasOwnProperty("count")) {
        react["count"] = 0
      } else {
        react.count ++
      }
      if(react.count >= react.respond.length-1 &amp;&amp; react.hasOwnProperty("next")) {
        //this.callback(react.next)
        if(react.next) {
          return_value["next"] = react.next
        }
      }
      
      if(react.count &lt; react.respond.length) {
        // log.debug(this.name, "Response no." + react.count + ": " + react.respond[react.count])
        //return({type:"respond", text:react.respond[react.count]})
        return_value["type"] = "respond"
        return_value["text"] = react.respond[react.count]
        return(return_value)
      }
      log.debug(this.name, "No response left. Ignoring no. " + react.count)
      return({type:'ignore'})
    } else {
      react["count"] = 0
      if(react.hasOwnProperty("next")) {
        //this.callback(react.next)
        return_value["next"] = react.next
      }
      //return({type:'ignore'})
      return_value["type"] = "ignore"
      return(return_value)
    }
  }
  
  cancel() {
    this.agent.cancelSmsIn(this.player.telnumber, this.path)
    if(this.hasOwnProperty("timer")) {
      clearTimeout(this.timer)
      log.debug(this.name, "timeout canceled")
    }
  }
}

/**
* note on using the say property and special characters:
* https://www.twilio.com/docs/voice/twiml/say#hints
*/
class Call extends Conversation {
  constructor(properties) {
    super(properties)
    
    this.canceled = false
    this.waiting = false
    
    this.name = "call " + this.player.telnumber
    
    
  }
  
  /**
  * resolve variables if there are any
  *
  */
  init() {
    return new Promise((resolve, reject) => {
      if(Array.isArray(this.sayplay)) {
        Promise.all(this.sayplay.map(res => new Promise((resolve, reject) => {
          if(res.hasOwnProperty("say")) {
            this.variables.review(res.say)
            .then(reviewed_text => {
              res.say = reviewed_text
              return resolve(undefined)
            })
            .catch(error => {
              return reject(error)
            })
          } else {
            return resolve(undefined)
          }
        })))
        .then(result => {
          return resolve(undefined)
        })
        .catch(error => {
          log.error(this.name, error)
          return resolve(error)
        })
      } else {
        return resolve(undefined)
      }
    })
    
  }
  
  /**
  * make an outbound call and register call status to get feedback from twilio
  */
  outbound() {
    this.was_answered = false
    this.agent.registerCallStatus(this.player.telnumber, {route:this.route.bind(this)})
    this.agent.call(this.player.telnumber)
  }
  
  /**
  * install a listener for incoming calls.
  *
  */
  inbound() {
    this.waiting = true
    this.agent.registerCallIn(this.player.telnumber, this.path, this.priority, this.incoming.bind(this))
  }
  
  /**
  * function is executed once a call comes in if inbound calls were registered
  * forwards to routing and installs listener for call status events from twilio
  */
  incoming(telnumber) {
    //this.waiting = false
    this.agent.registerCallStatus(this.player.telnumber, {route:this.route.bind(this)})
    log.info(this.name, 'incoming call')
    
    return this.route("incoming", {From:telnumber, telnumber:telnumber})
  }
  
  /**
  * decide how to react on call events from twilio
  */
  route(status, data) {
    // log.info(this.name, 'route call with status: ' + status)
    switch(status) {
      case "completed":
        this.was_answered = false
        log.debug(this.name, "Call completed after " + data.CallDuration + " seconds")
        if(this.hasOwnProperty("next")) {
          this.callback(this.next)
        }
        this.agent.cancelCallStatus(this.player.telnumber)
        return({type:"ignore"})
        break
        
      case "in-progress":
      case "incoming":
        if(this.was_answered) {
          return({type:"ignore"})
        } else {
          this.was_answered = true
          if(this.hasOwnProperty("sayplay")) {
            
            // Set to player language if not specified otherwise
            for(let sp of this.sayplay) {
    					if(sp.hasOwnProperty("say")) {
                if(!sp.hasOwnProperty("language")) {
                  if(this.player.hasOwnProperty("language")) {
                    if(this.player.language == "en") {
                      sp["language"] = "en-GB"
                    } else if(this.player.language == "de") {
                      sp["language"] = "de-DE"
                    }
                  }
                }
              }
            }
            
            return({type:"sayplay",answered:this.sayplay})
          } else if(this.hasOwnProperty("flow")) {
            for(let flow in this.flows) {
              if(this.flows[flow].friendlyName == this.flow) {
                return({type:"flow",sid:this.flows[flow].sid, account:this.settings.sid, flowname:this.flow})
              }
            }
            log.error(this.name, this.flow + " doesn't name an existing Studio Flow")
          } else if (this.hasOwnProperty("reject")) {
            log.debug(this.name, "Reject Call.")
            return({type:"reject",reason:this.reject})
          } else {
            log.warn(this.name, "no reaction on established call defined. Call will be rejected.")
            return({type:"reject",reason:"busy"})
          }
        }
        break
      
      case "busy":
      case "failed":
      case "no-answer":
      case "interrupted":
        this.was_answered = false
        if(this.hasOwnProperty("failed")) {
          if(this.failed.hasOwnProperty("next")) {
            this.callback(this.failed.next)
          }
        } else {
          log.warn(this.name, "Call failed with no next failcue defined")
        }
        log.warn(this.name, "Call failed. Telnumber: " + this.player.telnumber + " Reason: " + status)
        this.agent.cancelCallStatus(this.player.telnumber)
        return({type:"ignore"})
        break
      default:
        return({type:"ignore"})
    }
  }
  
  /**
  * cancel inbound listener if there is one and status event listener if there is one
  */
  cancel() {
    if(!this.canceled) {
      this.canceled = true
      if(this.waiting) {
        this.agent.cancelCallIn(this.player.telnumber, this.path)
      } else {
        this.agent.cancelCallStatus(this.player.telnumber)
      }
    }
  }
}

/**
* DEPRECATED
*/
class CallIn extends Conversation {
  constructor(properties) {
    super(properties)
    
    this.agent.registerCallIn(properties.player.telnumber, this.path, properties.priority, this.incoming.bind(this))
  }
  
  incoming(telnumber) {
    this.agent.registerCallStatus(properties.player.telnumber, {route:this.route.bind(this)})
    log.info(this.player.telnumber, 'incoming call')
    
    return this.route("incoming", {From:telnumber, telnumber:telnumber})
    
    if(this.hasOwnProperty("say")) {
      return({type:"say",text:this.say})
    }
    if (this.hasOwnProperty("play")) {
      
    }
    
    if (this.hasOwnProperty("flow")) {
      for(let flow in this.flows) {
        if(this.flows[flow].friendlyName == this.flow) {
          return({type:"flow",sid:this.flows[flow].sid, account:this.settings.sid, flowname:this.flow})
        }
      }
      log.warn(this.name, this.flow + " doesn't name an existing Studio Flow")
    }
    
    if (this.hasOwnProperty("reject")) {
      return({type:"reject",reason:this.reject})
    }
    
    return({type:"hangup"})
  }
  
  cancel() {
    this.agent.cancelCallIn(this.player.telnumber, this.path)
  }
}

module.exports.Plugin = Switchboard
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
